IO::Hexdump - Crystal 1.20.2

# class IO::Hexdump

- IO::Hexdump
- IO
- Reference
- Object

##
Overview

IO object that prints an hexadecimal dump of all transferred data.

Especially useful for debugging binary protocols on an IO, to understand better when and how data is sent or received.

By default `IO::Hexdump` won't print anything; you must specify which of `#read`, `#write` or both you want to print.

Example:

    require "io/hexdump"
    socket = IO::Memory.new("abc")
    io = IO::Hexdump.new(socket, output: STDERR, read: true)

When data is read from io it will print something akin to the following on STDERR:

    00000000  50 52 49 20 2a 20 48 54  54 50 2f 32 2e 30 0d 0a  PRI * HTTP/2.0..
    00000010  0d 0a 53 4d 0d 0a 0d 0a                           ..SM....
    00000000  00 00 00 04                                       ....
    00000000  00                                                .
    00000000  00 00 00 00                                       ....

##
Defined in:

io/hexdump.cr

##
Constructors

- .new(io : IO, output : IO = STDERR, read : Bool = false, write : Bool = false)

##
Instance Method Summary

- #close(*args, **options)
- #close(*args, **options, &)
- #closed?(*args, **options)
- #closed?(*args, **options, &)
- #flush(*args, **options)
- #flush(*args, **options, &)
- #peek(*args, **options)
- #peek(*args, **options, &)
- #pos(*args, **options)
- #pos(*args, **options, &)
- #pos=(arg)

  Sets the current position (in bytes) in this `IO`.

- #read(slice : Bytes) : Int32

  Reads at most slice.size bytes from this `IO` into slice.

- #read(*, buf : Bytes) : Int32

  DEPRECATED Use `#read(slice : Bytes)` instead

- #seek(*args, **options)
- #seek(*args, **options, &)
- #tty?(*args, **options)
- #tty?(*args, **options, &)
- #write(slice : Bytes) : Nil

  Writes the contents of slice into this `IO`.

- #write(*, buf : Bytes) : Nil

  DEPRECATED Use `#write(slice : Bytes)` instead

### Instance methods inherited from class `IO`

<<(obj : _) : self <<, close close, closed? : Bool closed?, each_byte(&) : Nil
each_byte each_byte, each_char(&) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, getb_to_end : Bytes getb_to_end, gets(delimiter : Char, limit : Int, chomp = false) : String | Nil
gets(chomp : Bool = true) : String | Nil
gets(limit : Int, chomp : Bool = false) : String | Nil
gets(delimiter : Char, chomp : Bool = false) : String | Nil
gets(delimiter : String, chomp = false) : String | Nil gets, gets_to_end : String gets_to_end, peek : Bytes | Nil peek, pos pos, pos=(value) pos=, print(obj : _) : Nil
print(*objects : _) : Nil print, printf(format_string : String, args : Array | Tuple) : Nil
printf(format_string : String, *args) : Nil printf, puts(string : String) : Nil
puts(obj : _) : Nil
puts : Nil
puts(*objects : _) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, & : IO -> ) read_at, read_byte : UInt8 | Nil read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char | Nil read_char, read_fully(slice : Bytes) : Int32 read_fully, read_fully?(slice : Bytes) : Int32 | Nil read_fully?, read_greedy(slice : Bytes) : Int32 read_greedy, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) : Int32 read_utf8, read_utf8_byte : UInt8 | Nil read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol | Nil = nil) : Nil set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) : Nil write_byte, write_bytes(object : _, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) : Nil write_bytes, write_string(slice : Bytes) : Nil write_string, write_utf8(slice : Bytes) : Nil write_utf8

### Class methods inherited from class `IO`

copy(src : IO, dst : IO, limit : Int) : Int64
copy(src : IO, dst : IO) : Int64 copy, pipe(read_blocking : Bool | Nil = nil, write_blocking : Bool | Nil = nil) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = nil, write_blocking = nil, &) pipe, same_content?(stream1 : IO, stream2 : IO) : Bool same_content?

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(io : IO, output : IO = STDERR, read : Bool = false, write : Bool = false) #

##
Instance Method Detail

def close(*args, **options) #
def close(*args, **options, &) #
def closed?(*args, **options) #
def closed?(*args, **options, &) #
def flush(*args, **options) #
def flush(*args, **options, &) #
def peek(*args, **options) #
def peek(*args, **options, &) #
def pos(*args, **options) #
def pos(*args, **options, &) #
def pos=(arg) #
Description copied from class IO

Sets the current position (in bytes) in this `IO`.

The `IO` class raises on this method, but some subclasses, notable `IO::FileDescriptor` and `IO::Memory` implement it.

    File.write("testfile", "hello")

    file = File.new("testfile")
    file.pos = 3
    file.gets_to_end # => "lo"

def read(slice : Bytes) : Int32 #
Description copied from class IO

Reads at most slice.size bytes from this `IO` into slice. Returns the number of bytes read, which is 0 if and only if there is no more data to read (so checking for 0 is the way to detect end of file).

    io = IO::Memory.new "hello"
    slice = Bytes.new(4)
    io.read(slice) # => 4
    slice          # => Bytes[104, 101, 108, 108]
    io.read(slice) # => 1
    slice          # => Bytes[111, 101, 108, 108]
    io.read(slice) # => 0

def read(*, buf : Bytes) : Int32 #

DEPRECATED Use `#read(slice : Bytes)` instead

def seek(*args, **options) #
def seek(*args, **options, &) #
def tty?(*args, **options) #
def tty?(*args, **options, &) #
def write(slice : Bytes) : Nil #
Description copied from class IO

Writes the contents of slice into this `IO`.

    io = IO::Memory.new
    slice = Bytes.new(4) { |i| ('a'.ord + i).to_u8 }
    io.write(slice)
    io.to_s # => "abcd"

def write(*, buf : Bytes) : Nil #

DEPRECATED Use `#write(slice : Bytes)` instead